backgating.menu <- function(action, window)
{
	
    dialog <- gtkDialogNewWithButtons("Backgating", window, "destroy-with-parent",                                           "gtk-ok", GtkResponseType["ok"], "gtk-cancel", GtkResponseType["cancel"])

    gtkWidgetSetSizeRequest(dialog, 400, 300)
      
    label <- gtkLabelNew("Create gate hierarchy in order for backgating")  
    dialog[["vbox"]]$packStart(label, FALSE, FALSE, 10)
       
    gates <- names(.guiEnv$Gate.list)
   
    hbox <- gtkHBox(TRUE, 5)
    
    ##for gate list
    view <- make.treeview(gates, "Gate List", "multiple")
    sw <- make.scrolled_window(view)
    hbox$packStart(sw, TRUE, TRUE, 0)
   
    ##for selected gate hierarchy in order
    gate_list <- NULL
    rdf.sel <- rGtkDataFrame(data.frame(cols=gate_list))
    view1 <- gtkTreeView(rdf.sel)
    col <- gtkTreeViewColumn("Hierarchy", gtkCellRendererText(), text = 0)
    view1$insertColumn(col, 0)
    view1$getSelection()$setMode("multiple")
    sw1 <- make.scrolled_window(view1)
    hbox$packStart(sw1, TRUE, TRUE, 0)
   
    ##button
    but.vbox <- gtkVBox(FALSE, 15)
    but <- gtkButton("Add")
    but.lf <- gtkButton("Remove")
    but.vbox$packStart(but, FALSE, FALSE, 30)
    but.vbox$packStart(but.lf, FALSE, FALSE, 20)
    hbox$packStart(but.vbox, TRUE, TRUE, 0)
    
    gSignalConnect(but, "clicked", add.cb, list(view, rdf.sel))
     
    gSignalConnect(but.lf, "clicked", remove.cb, list(view1, rdf.sel))
    
    dialog[["vbox"]]$packStart(hbox, TRUE, TRUE, 0)
   
 
    if(dialog$run() == GtkResponseType["ok"])

     {
     	  
        selected_gates <- rdf.sel[]
        inds <- match(selected_gates, names(.guiEnv$Gate.list))
        iset("value.x", inds) 
        openGraphics(inds, mode = 2)
    
     }
     dialog$destroy()         
    
    
}


